<?php

namespace Drupal\ubercart_funds\Plugin\Block;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Block\BlockBase;
use Drupal\Core\Session\AccountInterface;

/**
 * Provides a block for site balance.
 *
 * @Block(
 *   id = "user_balance",
 *   admin_label = @Translation("User balance")
 * )
 */
class FundsUserBalance extends BlockBase {

  /**
   * {@inheritdoc}
   */
  protected function blockAccess(AccountInterface $account) {
    return AccessResult::allowedIfHasPermission($account, 'deposit funds');
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    $account = \Drupal::currentUser();

    $connexion = \Drupal::database();
    $query = $connexion->query("SELECT balance FROM uc_funds_user_funds WHERE uid = :uid", [
      ':uid' => $account->id(),
    ]);
    $balance = $query->fetchObject();

    return [
      '#theme' => 'user_balance',
      '#balance' => $balance ? uc_currency_format($balance->balance / 100) : 0,
      '#cache' => [
        'max-age' => 0,
      ],
    ];
  }

}
