<?php

namespace Drupal\ubercart_funds\Plugin\Block;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Block\BlockBase;
use Drupal\Core\Session\AccountInterface;

/**
 * Provides a block for site balance.
 *
 * @Block(
 *   id = "user_operations",
 *   admin_label = @Translation("User operations")
 * )
 */
class FundsUserOperations extends BlockBase {

  /**
   * {@inheritdoc}
   */
  protected function blockAccess(AccountInterface $account) {
    return AccessResult::allowedIfHasPermission($account, 'deposit funds');
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    $account = \Drupal::currentUser();
    $withdrawal_methods = \Drupal::config('uc_funds.settings')->get('withdrawal_methods')['methods'];

    return [
      '#theme' => 'user_operations',
      '#withdrawal_methods' => $withdrawal_methods,
    ];
  }

}
